hdu 1806 Frequent values (RMQ)

Problem Description
You are given a sequence of n integers a 1 , a 2 , ... , a n in non-decreasing order. In addition to that, you are given several queries consisting of indices i and j (1 ≤ i ≤ j ≤ n). For each query, determine the most frequent value among the integers a i , ... , a j . 

 

Input
The input consists of several test cases. Each test case starts with a line containing two integers n and q (1 ≤ n, q ≤ 100000). The next line contains n integers a 1 , ... , a n(-100000 ≤ a i ≤ 100000, for each i ∈ {1, ..., n}) separated by spaces. You can assume that for each i ∈ {1, ..., n-1}: a i ≤ a i+1. The following q lines contain one query each, consisting of two integers i and j (1 ≤ i ≤ j ≤ n), which indicate the boundary indices for the query. 

The last test case is followed by a line containing a single 0. 

 

Output
For each query, print one line with one integer: The number of occurrences of the most frequent value within the given range. 
 

Sample Input
  
  
10 3 -1 -1 1 1 1 1 3 10 10 10 2 3 1 10 5 10 0
 

Sample Output
  
  
1 4 3
Hint
A naive algorithm may not run in time!
 

Source
 


题意:查询某个区间出现次数最多数字的次数.

思路:RMQ算法,由于给出的序列是非减的,我们可以将序列优化一下,将数字出现的次数作为序列值;

列如:(1,1,,2,2,2,3)  优化成(2,3,1)

于是RMQ;

代码:

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
using namespace std;
const int N=100010;
int a[N],b[N];
int dp[N][20];
void make_rmq(int n)
{
    for(int i=0;i<n;i++)
        dp[i][0]=b[i];
    for(int j=1;(1<<j)<n;j++)
        for(int i=0;i+(1<<j)<n;i++)
            dp[i][j]=max(dp[i][j-1],dp[i+(1<<(j-1))][j-1]);
}
int find1(int l,int r,int w)
{
    while(l<r)
    {
        int temp=(l+r)/2;
        if(a[temp]>=w)
            r=temp;
        else
            l=temp+1;
    }
    return l;
}
int rmp(int l,int r)
{
    int n=(int)(log(r-l+1.0)/log(2));
    return max(dp[l][n],dp[r-(1<<n)+1][n]);
}
int main()
{
    int n,m;
    while(~scanf("%d",&n))
    {
        if(!n)
            break;
        scanf("%d",&m);
        for(int i=0;i<n;i++)
            scanf("%d",&a[i]);
        int t=1,temp=a[n-1];
        b[n-1]=1;
        for(int i=n-2;i>=0;i--)
        {
            if(temp==a[i])
                t++;
            else
            {
                temp=a[i];
                t=1;
            }
            b[i]=t;
        }
        make_rmq(n);
        while(m--)
        {
            int l,r;
            scanf("%d%d",&l,&r);
            l--;
            r--;
            int tt=find1(l,r,a[r]);
            int ans=r-tt+1;
            r=tt-1;
            if(l>r)
                printf("%d\n",ans);
            else
                printf("%d\n",max(ans,rmp(l,r)));
        }
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值